﻿Imports System.IO

Public Class frmTreeviewFromFile
   Private _FileListData As New FileInfo("..\..\File.txt")
   Private _SwitchListData As New FileInfo("..\..\VbHelp.csv")

   Public Sub New()
      InitializeComponent()
#If True Then
      btLoadSwitchList_Click(Nothing, Nothing)
#ElseIf True Then
      btReLoad_Click(Nothing, Nothing)
#ElseIf True Then
#End If
   End Sub

   Private Sub btReLoad_Click(sender As Object, e As EventArgs) Handles btLoadFileList.Click
      TreeView1.Nodes.Clear()
      For Each line In File.ReadAllLines(_FileListData.FullName)
         With TreeView1.Nodes.Approach(line.Split("\"c))
            Dim nodes = If(.Node Is Nothing, TreeView1.Nodes, .Node.Nodes)
            For Each sg In .Segments.Skip(.StepsDone)
               Dim indx = Not nodes.FindIndexByText(sg)
               nodes = nodes.Insert(indx, sg).Nodes
            Next
         End With
      Next
      TreeView1.ExpandAll()
   End Sub

   Private Sub btTest_Click(sender As Object, e As EventArgs) Handles btTest.Click
      Using wri = New StreamWriter(_FileListData.OpenWrite)
         For Each di In New DirectoryInfo("..\..\..").GetFiles("*.*", SearchOption.AllDirectories)
            wri.WriteLine(di.FullName)
         Next
      End Using
   End Sub

   Private Sub btLoadSwitchList_Click(sender As Object, e As EventArgs) Handles btLoadSwitchList.Click
#If False Then
Das Dateiformat ist lausig, man muss sich was ausdenken, was mit leeren Zellen zu geschehen hat.
Und es soll garnet aus allen Spalten Treenodes generiert wern, sondern nur aus den ersten 5 Spalten.
Und aus der 5, Spalte auch nicht, wenn die Zelle leer ist.
#End If
      Const maxLevel = 5
      TreeView1.BeginUpdate()
      TreeView1.Nodes.Clear()
      Dim allFields = File.ReadAllLines(_SwitchListData.FullName).Select(Function(line) line.Split({Tab}, maxLevel, StringSplitOptions.None)).ToArray
      Dim oldFields = allFields(0)
      For Each fields In allFields.Skip(1)
         For i = 0 To maxLevel - 2 ' leere Zellen mit Inhalten vorheriger Zeilen füllen
            If fields(i) = "" Then fields(i) = oldFields(i)
         Next
         fields(maxLevel - 1) = fields(maxLevel - 1).Replace(Tab, "   ") ' weitere Einträge als einen behandeln, auf maxLevel-Ebene
         With TreeView1.Nodes.Approach(fields)
            Dim nodes = If(.Node Is Nothing, TreeView1.Nodes, .Node.Nodes)
            For Each sg In .Segments.Skip(.StepsDone)
               If sg.Trim = "" Then Continue For
               Dim indx = Not nodes.FindIndexByText(sg)
               nodes = nodes.Insert(indx, sg).Nodes
            Next
         End With
         oldFields = fields
      Next
      TreeView1.ExpandAll()
      TreeView1.EndUpdate()
   End Sub
End Class
